unit Abak3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, Printers, ExtCtrls, MPlayer;
const
  ver='3.27';
  len=255;
type
  TForm1 = class(TForm)
    BtNew: TSpeedButton;
    BtOpen: TSpeedButton;
    BtSave: TSpeedButton;
    BtRun: TSpeedButton;
    BtPrint: TSpeedButton;
    MmProg: TMemo;
    BtHelp: TSpeedButton;
    MmHelp: TMemo;
    Vars: TStringGrid;
    DlgOpen: TOpenDialog;
    DlgSave: TSaveDialog;
    BtDoc: TSpeedButton;
    BtProg: TSpeedButton;
    BtVars: TSpeedButton;
    PnPict: TPanel;
    LbNom: TLabel;
    Sprt: TImage;
    Player: TMediaPlayer;
    Scr: TScrollBox;
    Pict: TImage;
    Bevel1: TBevel;
    TmStart: TTimer;
    PnStart: TPanel;
    Label1: TLabel;
    Image1: TImage;
    procedure BtRunClick(Sender: TObject);
    procedure BtHelpClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure BtNewClick(Sender: TObject);
    procedure BtOpenClick(Sender: TObject);
    procedure BtSaveClick(Sender: TObject);
    procedure BtPrintClick(Sender: TObject);
    procedure MmProgChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtProgClick(Sender: TObject);
    procedure BtDocClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MmProgKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MmProgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtVarsClick(Sender: TObject);
    procedure PictMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PictMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure VarsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure VarsKeyPress(Sender: TObject; var Key: Char);
    procedure TmStartTimer(Sender: TObject);
  private
    Modify,Trace,Hprint:boolean;{  .,  }
    tkey:string;{}
    Htext,Rtext:string;{ ,}
    Rfon,Rcolor:tColor;{    }
    tx,ty,mousex,mousey,t:longint;
    F:textfile; Fm:longint;
  public
    procedure Mesg(n:string);
    function Dial(s:string):boolean;
    procedure Err(n:string);
    Function Calc(s:string):string;
    Procedure PutVar(n,v:string);
    Function GetVar(n:string):string;
    Procedure DelVar(n:string);
    function DefVar(n:string):longint;
    function Stp(x,y:extended):extended;
    function num(s:string):extended;
    function clr(s:string):tColor;
    procedure Run;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Err(n:string);
begin
  Mesg(':'+n+#13+' :'+inttostr(t+1));
  BtRun.Down:=false;
end;

procedure TForm1.Mesg(n:string);
begin
  Application.MessageBox(Pchar(n),Pchar(PnStart.Caption),Mb_Ok);
end;

function TForm1.Dial(s:string):boolean;
begin
 result:=Application.MessageBox(PChar(s),Pchar(PnStart.Caption),Mb_YesNo)=6;
end;

function TForm1.num(s:string):extended;
var p:longint;
begin
  try
    p:=pos('.',s);if p>0 then s[p]:=DecimalSeparator;
    result:=StrToFloat(s);
  except
    result:=0;
    Err('  :'+s);
  end;
end;

function IsNum(s:string):boolean;
var p:longint;
begin
  result:=true;
  try
    p:=pos('.',s);if p>0 then s[p]:=DecimalSeparator;
    StrToFloat(s);
  except
    result:=false;
  end;
end;

function kop(s:string):string;
var p:longint;r:extended;
begin
  try
    p:=pos('.',s);if p>0 then s[p]:=DecimalSeparator;
    r:=StrToFloat(s);
    result:=FormatFloat('    0.00',r);
  except
    result:=s;
  end;
end;

procedure TForm1.PutVar(n,v:string);
var y:longint;
begin
  n:=AnsiUpperCase(trim(n));
  y:=DefVar(n);
  if y<0 then
  begin
    y:=1;
    while (y<Vars.RowCount)
     and (Vars.Cells[0,y]<>'') do inc(y);
    if y=Vars.RowCount
    then Vars.RowCount:=y+1;
    Vars.Cells[0,y]:=n;
  end;
  Vars.Cells[1,y]:=v;
end;

function oppos(a,b:string):longint;
var i:longint;vv:boolean;
begin //,         
  vv:=false;
  for i:=1 to length(b) do
  if b[i]='"' then vv:=not vv
  else if vv then b[i]:=' '
  else b[i]:=UpCase(b[i]);
  result:=pos(a,b);
end;

function Moment(Tm:tDateTime):string;
var H,M,S,D:word;
begin
  DecodeTime(Tm,H,M,S,D);
  Result:=FloatToStr(H*3600+M*60+S+D/1000);
end;

Function TForm1.GetVar(n:string):string;
var y:longint;
begin
  n:=AnsiUpperCase(trim(n));
  y:=DefVar(n);
  if y>=0
  then result:=Vars.Cells[1,y] else
  begin
      if n='SCRL'
      then Result:=IntToStr(PnPict.Width)
      else if n='SCRH'
      then Result:=IntToStr(PnPict.Height)
      else if n='SCRY'
      then Result:=IntToStr(ty)
      else if (n='TRUE') or (n='FALSE')
      then Result:=n
      else if n='EOF'
      then begin
        if (Fm<>1) or EOF(F) then Result:='TRUE'
        else Result:='FALSE'
      end
      else if n='MOMENT'
      then Result:=Moment(Time)
      else if n='TIME'
      then Result:=FormatDateTime('hh.nn',Time)
      else if n='DATE'
      then Result:=FormatDateTime('dd.mm',Date)
      else if n='DDMMYY'
      then Result:=FormatDateTime('dd.mm.yy',Date)
      else if n='DAY'
      then Result:=FormatDateTime('dd',Date)
      else if n='WEEK'
      then begin
        Result:=IntToStr(DayOfWeek(Date)-1);
        if Result='0' then Result:='7';
      end
      else if n='MONTH'
      then Result:=FormatDateTime('mm',Date)
      else if n='YEAR'
      then Result:=FormatDateTime('yyyy',Date)
      else if n='VER'
      then Result:=ver
      else if n='MOUSEX'
      then Result:=IntToStr(mouseX)
      else if n='MOUSEY'
      then Result:=IntToStr(mouseY)
      else if n='INKEY' then
      begin
        Application.processmessages;
        Result:=Tkey;
        Tkey:='';
      end else
      begin
        result:='';
        Err(' :'+n);
      end;
  end;
end;

procedure TForm1.DelVar(n:string);
var y:longint;
begin
  y:=DefVar(n);
  if y>0 then Vars.Cells[0,y]:='';
end;

function TForm1.DefVar(n:string):longint;
var y:longint;
begin
  n:=AnsiUpperCase(trim(n));
  y:=0;
  while (Vars.Cells[0,y]<>n)
   and (y<Vars.RowCount) do inc(y);
  if y<Vars.RowCount
  then result:=y else result:=-1;
end;

function TForm1.Stp(x,y:extended):extended;
begin //x^y
  try
    if (x=0) and (y<>0) then result:=0 else
    if (x<>0) and (y=0) then result:=1 else
    if (x<0)
    and (trunc(y)=y) then
    begin
      if odd(trunc(y))
      then result:=-exp(y*ln(abs(x)))
      else result:=exp(y*ln(abs(x)));
    end
    else result:=exp(y*ln(x));
  except
    Err(floatToStr(x)+'^'+floatToStr(y));
  end;
end;

function TForm1.Calc(s:string):string;
const m=20;{. }
var
  i,x,u,p:longint;
  n,z:string;
  k:boolean;
  a:array[0..m] of string;//
  b:array[1..m] of longint;//
  c:array[1..m] of char;//
begin
  result:='';
  s:=trim(s);
  k:=false;{}
  u:=0;{}
  p:=0;{}
  a[0]:='';
  n:='';//
  z:='';//
  i:=1;
  while i<=length(s) do
  begin
    if k and (s[i]<>'"') then z:=z+s[i]
    else
    case s[i] of
     '"':k:=not k;
     ' ','(':begin
           n:=UpperCase(n);
           if ('TAB'=copy(n,1,3)) {J}
           or (n='ASK')
           or (n='ATN')
           or (n='ABS') {B}
           or (n='COS')
           or (n='CHR') {V}
           or (n='DEF')
           or (n='EXP')
           or (n='FIRST')
           {G LEN}
           {H >=}
           or (n='INT')
           or (n='ISN') {X}
           {J TAB}
           or (n='KOP')
           or (n='LEN')
           or (n='LN')
           or (n='LAST') {W}
           {M <=}
           or (n='NOT')
           or (n='ORD')
           or (n='PSTR')
           {Q CHR}
           or (n='RND')
           or (n='SIN')
           {T TAB}
           or (n='UPC')
           or (n='MIN') {|}
           or (n='MAX') {V}
           {W LAST}
           or (n='XPS')
           or (n='YPS')
           {Z ISN}
           then
           begin
             a[u]:='';
             if u<m then inc(u) else
               Err(' :'+s);
             b[u]:=p+50;
             c[u]:=UpCase(n[1]);
             if n='NOT' then b[u]:=p+45 else
             if n='ASK' then c[u]:='_' else
             if n='ABS' then c[u]:='B' else
             if n='ISN' then c[u]:='Z' else
             if n='CHR' then c[u]:='Q' else
             if n='LAST' then c[u]:='W' else
             if n='LEN' then c[u]:='G' else
             if n='MAX' then c[u]:='V' else
             if n='MIN' then c[u]:='|' else
             if 'TAB'=copy(n,1,3) then
             begin
               c[u]:='J';
               a[u-1]:='15';
               delete(n,1,3);
               if n<>'' then a[u-1]:=n;
             end;
             a[u]:='';
             n:='';
           end;
           if s[i]='(' then p:=p+100;
         end;
     '[':begin
          x:=pos(']',copy(s,i+1,len));
          if x=0 then
            Err('  "]"  :'+s);
          n:=n+'['+Calc(Copy(s,i+1,x-1))+']';
          s:=copy(s,1,i)+copy(s,i+x+1,len);
         end;
     ')':begin
       p:=p-100;
       if p<0 then
         Err(' ")"  :'+s);
     end;
     '0'..'9','.',',':
       if n=''
       then z:=z+s[i]
       else n:=n+s[i];
     '-':begin
           if n<>'' then z:=GetVar(n);
           if z=''
           then a[u]:='0'
           else a[u]:=z;
           if u<m then inc(u) else
             Err(' :'+s);
           a[u]:='';
           if z=''
           then b[u]:=p+35
           else b[u]:=p+10;
           c[u]:=s[i];
           n:=''; z:='';
         end;
     '+',';','*','/',':','&','?','<','>','=','#','~','^','@':begin
        if n<>'' then z:=GetVar(n);
        a[u]:=z;
        if u<m then inc(u) else
          Err(' :'+s);
        a[u]:='';
        if s[i] = '?'
        then b[u]:=p+3 else
        if s[i] = '&'
        then b[u]:=p+4 else
        if s[i] in ['<','>','=','#','~']
        then b[u]:=p+6 else
        if s[i] = '+'
        then b[u]:=p+10 else
        if s[i] in ['*','/']
        then b[u]:=p+20 else
        if s[i] = '^'
        then b[u]:=p+25
        else b[u]:=p+2;{ ; :}
        c[u]:=s[i];
        n:=''; z:='';
        if (s[i]='<') and (copy(s,i+1,1)='>')
        then
        begin
          c[u]:='\'; s[i+1]:=' ';
        end;
        if (s[i]='<') and (copy(s,i+1,1)='=')
        then
        begin
          c[u]:='M'; s[i+1]:=' ';
        end;
        if (s[i]='>') and (copy(s,i+1,1)='=')
        then
        begin
          c[u]:='H'; s[i+1]:=' ';
        end;
     end;
     else //   CASE
      if z='' then n:=n+s[i]
      else Err(s);
    end;{case}
    inc(i);
  end;{for}
  if n<>'' then z:=GetVar(n);
  a[u]:=z;
  while u>0 do
  begin
    p:=1;
    for i:=2 to u do if b[p]<b[i] then p:=i;
    case c[p] of
     'A':a[p-1]:=floatToStr(arctan(num(a[p])));
     'B':a[p-1]:=floatToStr(abs(num(a[p])));
     'C':a[p-1]:=floatToStr(cos(num(a[p])));
{DEF}'D':if DefVar(a[p])>=0
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
{EXP}'E':a[p-1]:=floatToStr(exp(num(a[p])));
     'F':a[p-1]:=copy(a[p],1,1);
     'P':a[p-1]:=copy(a[p],1,length(a[p])-1);
     'W':a[p-1]:=copy(a[p],2,len);
     'G':a[p-1]:=intToStr(Length(a[p]));
     'I':a[p-1]:=floatToStr(int(num(a[p])));
     'J':begin {TAB}
           while length(a[p])<num(a[p-1]) do a[p]:=a[p]+' ';
           a[p-1]:=a[p];
         end;
{KOP}'K':a[p-1]:=kop(a[p]);
{LN} 'L':a[p-1]:=floatToStr(ln(num(a[p])));
{NOT}'N':if (UpperCase(a[p])='TRUE')
         then a[p-1]:='FALSE'
         else a[p-1]:='TRUE';
{ORD}'O':if a[p]>''
       then a[p-1]:=floatToStr(ord(a[p,1]))
       else a[p-1]:='0';
{CHR}'Q':a[p-1]:=a[p-1]+chr(trunc(num(a[p])));
{RND}'R':a[p-1]:=floatToStr(random(trunc(num(a[p]))));
{SIN}'S':a[p-1]:=floatToStr(sin(num(a[p])));
     'U':a[p-1]:=AnsiUpperCase(a[p]);
{MAX}'V':begin
           i:=pos(':',a[p]);
           if i=0 then err('   MAX :'+a[p]);
           n:=copy(a[p],1,i-1);
           z:=copy(a[p],i+1,99);
           if num(n)>num(z)
           then a[p-1]:=n
           else a[p-1]:=z;
         end;
{MIN}'|':begin
           i:=pos(':',a[p]);
           if i=0 then err('   MIN :'+a[p]);
           n:=copy(a[p],1,i-1);
           z:=copy(a[p],i+1,99);
           if num(n)<num(z)
           then a[p-1]:=n
           else a[p-1]:=z;
         end;
     'X':if pos(':',a[p])=0
         then err('   XPS :'+a[p])
         else a[p-1]:=copy(a[p],1,pos(':',a[p])-1);
     'Y':if pos(':',a[p])=0
         then err('   YPS :'+a[p])
         else a[p-1]:=copy(a[p],pos(':',a[p])+1,99);
{ISN}'Z':if IsNum(a[p])
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     '<':if (isnum(a[p-1]) and isnum(a[p]) and (num(a[p-1])<num(a[p]))
         or (not isnum(a[p-1]) or not isnum(a[p])) and (a[p-1]<a[p]))
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     'M':if (isnum(a[p-1]) and isnum(a[p]) and (num(a[p-1])<=num(a[p]))
         or (not isnum(a[p-1]) or not isnum(a[p])) and (a[p-1]<=a[p]))
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     '>':if (isnum(a[p-1]) and isnum(a[p]) and (num(a[p-1])>num(a[p]))
         or (not isnum(a[p-1]) or not isnum(a[p])) and (a[p-1]>a[p]))
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     'H':if (isnum(a[p-1]) and isnum(a[p]) and (num(a[p-1])>=num(a[p]))
         or (not isnum(a[p-1]) or not isnum(a[p])) and (a[p-1]>=a[p]))
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     '=':if (a[p-1]=a[p]) or (isnum(a[p-1]) and isnum(a[p]) and
          (num(a[p-1])=num(a[p]))) then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     '\':if  (a[p-1]<>a[p]) or (isnum(a[p-1]) and isnum(a[p]) and
          (num(a[p-1])<>num(a[p]))) then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     '~':if AnsiUpperCase(Trim(a[p-1]))=AnsiUpperCase(Trim(a[p]))
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     '#':if AnsiUpperCase(a[p-1])<>AnsiUpperCase(a[p])
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     '+':a[p-1]:=floatToStr(num(a[p-1])+num(a[p]));
     '-':a[p-1]:=floatToStr(num(a[p-1])-num(a[p]));
     '*':a[p-1]:=floatToStr(num(a[p-1])*num(a[p]));
     '^':a[p-1]:=floatToStr(stp(num(a[p-1]),num(a[p])));
     '/':if num(a[p])<>0
       then a[p-1]:=floatToStr(num(a[p-1])/num(a[p]))
       else Err('   :'+s);
     '&':if (a[p-1]='TRUE') and (a[p]='TRUE')
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     '?':if (a[p-1]='TRUE') or (a[p]='TRUE')
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
{ASK}'_':if Dial(a[p])
         then a[p-1]:='TRUE' else a[p-1]:='FALSE';
     ';':a[p-1]:=a[p-1]+a[p];
     ':':a[p-1]:=a[p-1]+':'+a[p];
     '@':a[p-1]:=IntToStr(pos(AnsiUpperCase(a[p-1]),AnsiUpperCase(a[p])));
    end;{case}
    for i:=p to u-1 do
    begin
      a[i]:=a[i+1];
      b[i]:=b[i+1];
      c[i]:=c[i+1];
    end;
    dec(u);
  end;
  result:=a[0];
end;

function TForm1.clr(s:string):tColor;
begin
  s:=UpperCase(Trim(s));
  if s='RED' then Result:=ClRed else
  if s='GREEN' then Result:=ClGreen else
  if s='AQUA' then Result:=ClAqua else
  if s='LIME' then Result:=ClLime else
  if s='YELLOW' then Result:=ClYellow else
  if s='BLUE' then Result:=ClBlue else
  if s='NAVY' then Result:=ClNavy else
  if s='DARK' then Result:=ClGray else
  if s='GRAY' then Result:=ClSilver else
  if s='BLACK' then Result:=ClBlack else
  if s='WHITE' then Result:=ClWhite else
  if s='WINDOW' then Result:=ClWindow else
  if s='TEXT' then Result:=ClWindowText else
  if s='FACE' then Result:=ClBtnFace else
  Result:=StrToIntDef(s,0);

end;

procedure TForm1.BtRunClick(Sender: TObject);
begin
  Vars.SetFocus;{   .  }
  PnPict.Visible:=true;
  PnPict.BringToFront;
  Run;
end;

procedure TForm1.Run;
var
  p,q,x,y,ret,plen:longint;
  st:array[0..20] of longint;
  n,s,r:string;
  z:extended;
begin
  if not BtRun.Down then exit;
  Plen:=MmProg.Lines.Count;
  Hprint:=false;{  }
  Trace:=true;{   .}
  Tkey:='';
  Fm:=0;{ }
  Scr.HorzScrollBar.Position:=0;
  Scr.VertScrollBar.Position:=0;
  Pict.Cursor:=CrDefault;
  Pict.Canvas.Font:=MmHelp.Font;
  BtDoc.Down:=true;
  if Trace then Vars.RowCount:=1; {  }
  ret:=-1;{ GOSUB}
  t:=0;{ }
  while t<MmProg.Lines.Count do
  begin
    if Trace then
    begin
      LbNom.Caption:=IntToStr(t+1);
      Application.ProcessMessages;
    end;
    s:=Trim(MmProg.Lines[t]);
    r:=UpperCase(s);
    if 'CLS'=copy(r,1,3) then
    begin //  
      Delete(s,1,3);
      p:=oppos('HELP',s);
      if (p>0) or Hprint then
      begin
        if p>0 then delete(s,p,4);
        MmHelp.Lines.Clear;
      end;
      if trim(s)='' then q:=ClWhite
      else q:=clr(calc(s));
      if (p>0) or Hprint then
      begin
        MmHelp.Color:=q;
      end else
      begin
        Pict.Canvas.Brush.Style:=BsSolid;
        Pict.Canvas.Brush.Color:=q;
        Pict.Canvas.Pen.Color:=q;
        Pict.Canvas.Pen.Style:=psSolid;
        Pict.Canvas.Pen.Width:=1;
        Pict.Canvas.Rectangle(0,0,Pict.Width,Pict.Height);
        Pict.Canvas.Pen.Color:=0;
        tx:=1; ty:=1;{ PRINT}
      end;
    end else
    if 'DIM'=copy(r,1,3) then
    begin
      delete(s,1,3);
      s:=Trim(s);
      p:=pos('[',s);
      if p>0 then
      begin
        if copy(s,length(s),1)<>']' then
        begin
          Err('  "]"  :'+s);
          exit;
        end;
        n:=Calc(Copy(s,p+1,length(s)-p-1));
        q:=pos(':',n);
        if q=0 then
        begin
          if isNum(n)
          then
          for x:=1 to trunc(num(n)) do
           PutVar(copy(s,1,p)+inttostr(x)+']','0')
          else err('   :'+n);
        end else
        begin
          if isNum(copy(n,1,q-1))
          and isNum(copy(n,q+1,99))
          then
          for x:=1 to trunc(num(copy(n,1,q-1))) do
          for y:=1 to trunc(num(copy(n,q+1,99))) do
           PutVar(copy(s,1,p)+inttostr(x)+':'+inttostr(y)+']','0')
          else err('   :'+n);
        end;
      end else PutVar(s,'0');
    end else
    if 'LOAD'=copy(r,1,4) then
    begin
      delete(s,1,4);
      n:=calc(s);
      if pos('.',n)=0 then n:=n+'.ab';
      MmProg.Lines.LoadFromFile(n);
      Modify:=false;
      DlgSave.FileName:=n;
      Form1.Caption:=n;
      t:=-1;
    end else
    if 'SAVE'=copy(r,1,4) then
    begin
      delete(s,1,4);
      n:=calc(s);
      if n='' then n:=DlgSave.FileName;
      if pos('.',n)=0 then n:=n+'.ab';
      MmProg.Lines.SaveToFile(n);
      Modify:=false;
    end else
    if 'EDIT'=copy(r,1,4) then
    begin
      delete(s,1,4);
      p:=oppos(' TO ',s);
      if p>0 then
      begin
        y:=trunc(num(calc(copy(s,1,p-1))));
        n:=calc(copy(s,p+4,len));
        if (y>0) and (y<MmProg.Lines.Count)
        then MmProg.Lines[y-1]:=n
        else MmProg.Lines.Add(n);
        Modify:=true;
      end else err(' ... TO ?')
    end else
    if 'SET'=copy(r,1,3) then
    begin
      delete(s,1,3);
      s:=UpperCase(trimleft(s));
      p:=pos('CLEAR',s);
      if p>0 then
      begin
        delete(s,p,5);
        Vars.RowCount:=1;
      end;
      p:=pos('PLAYER',s);
      if p>0 then
      begin
        delete(s,p,6);
        Player.Visible:=true;
      end;
      p:=pos('SPEED',s);
      if p>0 then
      begin
        delete(s,p,5);
        trace:=false;
      end;
      p:=pos('MIN',s);
      if p>0 then
      begin
        delete(s,p,3);
        Application.Minimize;
      end;
      p:=pos('MID',s);
      if p>0 then
      begin
        delete(s,p,3);
        Form1.ClientWidth:=190;
        Form1.ClientHeight:=150;
      end;
      p:=pos('MAX',s);
      if p>0 then
      begin
        delete(s,p,3);
        Form1.WindowState:=WsMaximized;
      end;
      p:=pos('FULL',s);
      if p>0 then
      begin
        delete(s,p,4);
        Form1.BorderStyle:=BsNone;
        Form1.SetBounds(0,0,Screen.Width,Screen.Height);
        PnPict.SetBounds(0,0,ClientWidth,ClientHeight);
        Pict.Align:=AlClient;
      end;
      p:=pos('TOP',s);
      if p>0 then
      begin
        delete(s,p,3);
        Form1.FormStyle:=FsStayOnTop;
      end;
      p:=pos('DIALOG',s);
      if p>0 then
      begin
        delete(s,p,6);
        Form1.BorderStyle:=BsDialog;
      end;
      p:=pos('PROF',s);
      if p>0 then
      begin
        delete(s,p,4);
     //   BtVars.Visible:=false;
     //   BtProg.Visible:=false;
        PnPict.Top:=BtNew.Top;
        PnPict.Height:=ClientHeight-PnPict.Top-4;
        Form1.FormResize(Form1);
      end;
      p:=pos('NOSCROLL',s);
      if p>0 then
      begin
        delete(s,p,8);
        Pict.Align:=AlClient;
      end;
      p:=pos('SCROLL',s);
      if p>0 then
      begin
        delete(s,p,6);
        Pict.Align:=AlNone;
        Pict.Width:=1024;
        Pict.Height:=2048;
      end;
      p:=pos('WAIT',s);
      if p>0 then
      begin
        delete(s,p,4);
        Pict.Cursor:=CrHourGlass;
      end;
      p:=pos('CURSOR',s);
      if p>0 then
      begin
        delete(s,p,6);
        Pict.Cursor:=CrArrow;
      end;
      p:=pos('CROSS',s);
      if p>0 then
      begin
        delete(s,p,5);
        Pict.Cursor:=CrCross;
      end;
      p:=pos('HIDE',s);
      if p>0 then
      begin
        delete(s,p,4);
        Pict.Cursor:=CrNone;
      end;
      p:=pos('HELP',s);
      if p>0 then
      begin
        delete(s,p,4);
        MmHelp.Visible:=true;
        MmHelp.BringToFront;
        MmHelp.SetFocus;
        Hprint:=true;
      end;
      p:=pos('TEXT',s);
      if p>0 then
      begin
        delete(s,p,4);
        MmHelp.Lines.Clear;
        MmHelp.Visible:=true;
        MmHelp.BringToFront;
        MmHelp.SetFocus;
        Hprint:=true;
      end;
      p:=pos('PICT',s);
      if p>0 then
      begin
        delete(s,p,4);
        BtDocClick(BtDoc);
        Hprint:=false;
      end;
      p:=pos('PROG',s);
      if p>0 then
      begin
        delete(s,p,4);
        MmProg.Visible:=true;
        MmProg.BringToFront;
        BtProg.Down:=true;
      end;
    end else
    if 'FOR'=copy(r,1,3) then
    begin
      delete(s,1,3);
      s:=trimleft(s);
      p:=pos('=',s);
        if trace and (s[p-1]=':') then
        begin  Err('  :  =   FOR');
          exit;
        end;
        n:=UpperCase(trim(copy(s,1,p-1)));
        delete(s,1,p);
        p:=pos(' TO ',UpperCase(s));
        if p=0 then
        begin Err(' "TO"  .FOR');
          exit;
        end;
        r:=calc(copy(s,1,p-1));{ }
        delete(s,1,p+2);
        p:=pos(' STEP ',UpperCase(s));
        if p=0 then
        begin
          PutVar('STEP '+n,'1');
          z:=1;
        end else
        begin
          z:=num(copy(s,p+6,len));
          if z=0 then
          begin
            Err('STEP=0 ?');
            exit;
          end;
          delete(s,p,len);
      end;
      PutVar(n,r);
      PutVar('FOR '+n,IntToStr(t));{   }
      PutVar('STEP '+n,floatToStr(z));
      if s='' then
      begin Err('   .FOR');
        exit;
      end;
      s:=calc(s);{ }
      PutVar('NEXT '+n,s);
      if ((z>0) and (num(s)<num(r)+z))
      or ((z<0) and (num(s)>num(r)+z))
       then
      begin
        p:=1;//
        y:=t+1;// 
        while (y<MmProg.Lines.Count) do
        begin
          s:=UpperCase(Trimleft(MmProg.Lines[y]));
          if copy(s,1,3)='FOR' then p:=p+1 else
          if copy(s,1,4)='NEXT' then
          begin
            p:=p-1;
            if p=0 then
            begin
              t:=y;
              y:=MmProg.Lines.Count;
            end;
          end;
          inc(y);
        end;{while}
        if p<>0 then
        begin Err('FOR <> NEXT');
          exit;
        end;
      end;
    end else
    if 'NEXT'=copy(r,1,4) then
    begin
      delete(s,1,4);
      n:=trim(s);{  }
      if n='' then n:='0';
      z:=num(GetVar('STEP '+n));
      r:=(GetVar(n));{}
      s:=GetVar('NEXT '+n);{ }
      if ((z>0) and (num(s)>=num(r)+z))
      or ((z<0) and (num(s)<=num(r)+z)) then
      begin
        PutVar(n,floatToStr(num(r)+z));
        y:=StrToIntDef(GetVar('FOR '+n),-1);
        if y<0 then
        begin Err('NEXT  FOR');
          exit;
        end;
        t:=y;
      end;
    end else
    if 'WHILE'=copy(r,1,5) then
    begin
      delete(s,1,5);
      p:=pos(' DO',UpperCase(s));
      if p>0 then delete(s,p,3);
      s:=Uppercase(Calc(s));
      if s='FALSE' then
      begin // WEND
        p:=1;//
        y:=t+1;// 
        while (y<MmProg.Lines.Count) do
        begin
          s:=UpperCase(Trimleft(MmProg.Lines[y]));
          if copy(s,1,5)='WHILE' then p:=p+1 else
          if copy(s,1,4)='WEND' then
          begin
            p:=p-1;
            if p=0 then
            begin
              t:=y;
              y:=MmProg.Lines.Count;
            end;
          end;
          inc(y);
        end;{while}
        if p<>0 then
        begin Err('WHILE <> WEND');
          exit;
        end;
      end
      else if s<>'TRUE' then
      begin Err('    .WHILE:'+s);
        exit;
      end;
    end else
    if 'WEND'=copy(r,1,4) then
    begin
      y:=t-1;
      p:=1;
      While (y>=0) do
      begin
        s:=UpperCase(Trimleft(MmProg.Lines[y]));
        if copy(s,1,4)='WEND' then p:=p+1 else
        if copy(s,1,5)='WHILE' then
        begin
          p:=p-1;
          if p=0 then
          begin
            t:=y-1;
            y:=-1;
          end;
        end;
        dec(y);
      end;{while}
      if p<>0 then
      begin Err('WHILE <> WEND');
        exit;
      end;
    end else
    if 'IF'=copy(r,1,2) then
    begin
      delete(s,1,2);
      s:=trimleft(s);
      p:=pos(' THEN',UpperCase(s));
      if p>0 then delete(s,p,5) else p:=length(s)+1;
      if Trim(Copy(s,p,9))<>'' then
      begin Err(' THEN  ');
        exit;
      end;
      s:=Uppercase(Calc(s));
      if s='FALSE' then
      begin // ENDIF  ELSE
        p:=1;//
        y:=t+1;// 
        while (y<MmProg.Lines.Count) do
        begin
          s:=UpperCase(Trimleft(MmProg.Lines[y]));
          if (copy(s,1,4)='ELSE') and (p=1) then
          begin
            p:=0;
            t:=y;
            y:=MmProg.Lines.Count;
          end else
          if copy(s,1,2)='IF' then p:=p+1 else
          if copy(s,1,3)='END' then
          begin
            p:=p-1;
            if p=0 then
            begin
              t:=y;
              y:=MmProg.Lines.Count;
            end;
          end;
          inc(y);
        end;{while}
        if p<>0 then
        begin Err('IF <> END');
          exit;
        end;
      end
      else if s<>'TRUE'
      then begin Err('    .IF:'+s);exit;end;
    end else
    if 'ELSE'=copy(r,1,4) then
    begin
      p:=1;//
      y:=t+1;// 
      while (y<MmProg.Lines.Count) do
      begin
        s:=UpperCase(Trimleft(MmProg.Lines[y]));
        if copy(s,1,2)='IF' then p:=p+1 else
        if copy(s,1,3)='END' then
        begin
          p:=p-1;
          if p=0 then
          begin
            t:=y;
            y:=MmProg.Lines.Count;
          end;
        end;
        inc(y);
      end;{while}
      if p<>0
      then begin Err('IF <> END');exit;end;
    end else
    if 'END'=copy(r,1,3) then
    begin
      // 
    end else
    if 'EXIT'=copy(r,1,4) then
    begin
      BtRun.Down:=false;
      close;
    end else
    if 'INPUT'=copy(r,1,5) then
    begin
      delete(s,1,5);
      p:=oppos('FILENAME',s);
      if p>0 then
      begin
        n:=copy(s,p+8,len);
        while (n<>'') and (n[1] in [' ',',',';',':']) do delete(n,1,1);
        DlgOpen.FilterIndex:=3;
        if DlgOpen.Execute
        then r:=DlgOpen.FileName
        else r:='';
      end else
      begin
      s:=TrimLeft(s);
      if copy(s,1,1)='"' then
      begin
        delete(s,1,1);
        p:=pos('"',s);
        n:=copy(s,p+1,len);
        while (n<>'') and (n[1] in [' ',',',';',':']) do delete(n,1,1);
        s:=copy(s,1,p-1);
      end else
      begin
        n:=s;
        s:='';
      end;
      p:=pos('[',n);
      if p>0 then
      begin
        if copy(n,length(n),1)<>']' then
        begin
          Err('  "]"  :'+n);
          exit;
        end;
        n:=copy(n,1,p)+Calc(Copy(n,p+1,length(n)-p-1))+']';
      end;
      if s='' then s:=n;
      r:='';
      if Trace then
      begin
        if (n='') or (n[1] in ['0'..'9','+','-','*','/','.',',',';'])
        then
        begin
          Err('  :'+n);
          exit;
        end;
      end;
      if not InputQuery(PnStart.Caption,s,r) then
      Err(' ');
      end;
      PutVar(n,r);
    end else {----------------------------------}
    if 'GOSUB'=copy(r,1,5) then
    begin
      if ret>=20 then begin Err(' GOSUB');exit;end;
      delete(s,1,5);
      n:=UpperCase(Trim(s));
      if 'ON '=copy(n,1,3) then
      begin
        delete(n,1,3);
        n:=Calc(n);
      end;
      p:=pos(' ',n);
      if p=0 then p:=pos('(',n);
      if p>0 then
      begin
        r:=calc(copy(n,p,999));
        PutVar('ARG',r);
        n:=trim(copy(n,1,p-1));
      end else PutVar('ARG','');
      ret:=ret+1;
      st[ret]:=t;
      p:=0;// 
      y:=0;// 
      while (y<MmProg.Lines.Count) do
      begin
        s:=UpperCase(Trimleft(MmProg.Lines[y]));
        if (copy(s,1,3)='SUB') then
        begin
          delete(s,1,3);
          if n=trim(s) then
          begin
            p:=1;
            t:=y;
            y:=MmProg.Lines.Count+2;
          end;
        end;
        inc(y);
      end;{while}
      if p=0 then begin Err('GOSUB -  :'+n);exit;end;
    end else {----------------------------------}
    if 'RETURN'=copy(r,1,6) then
    begin
      if ret>=0 then
      begin
        t:=st[ret];
        ret:=ret-1;
      end else
      begin
        Err('RETURN  GOSUB');exit;
      end;
    end else {----------------------------------}
    if 'PAUSE'=copy(r,1,5) then
    begin
      delete(s,1,5);
      s:=trimleft(s);
      Mesg(calc(s));
    end else {----------------------------------}
    if 'PLAY'=copy(r,1,4) then
    begin
      delete(s,1,4);
      s:=trim(calc(s));
      if pos('.',s)=0 then s:=s+'.wav';
      try
        Player.FileName:=s;
        Player.Open;
        Player.Play;
        Application.ProcessMessages;
      except
        Err('  :'+s);
      end;
    end else
    if 'REM'=copy(r,1,3) then
    begin
      //
    end else
    if 'RUN'=copy(r,1,3) then
    begin
      delete(s,1,3);
      s:=trim(s);
      if s=''
      then t:=-1 else // 
      begin
        y:=StrToIntDef(calc(s),0);
        if (y<=0) or (y>Mmprog.Lines.Count) then Err('  :'+s)
        else t:=y-2;
      end;
      if Trace then Vars.RowCount:=1; {  }
      ret:=-1;{ GOSUB}
    end else
    if ('STOP'=copy(r,1,4)) or ('SUB'=copy(r,1,3)) then
    begin
      ret:=-1;{ GOSUB}
      if Player.Mode=MpPlaying then Player.Close;
      t:=MmProg.Lines.Count+1;
    end else
    if 'WRITE'=copy(r,1,5) then
    begin
      if Fm>1 then
      begin
        Delete(s,1,5);
        Writeln(F,calc(s));
      end else err('WRITE  OPEN ... TO WRITE/APPEND');
    end else
    if 'READ'=copy(r,1,4) then
    begin
      if Fm=1 then
      begin
        Delete(s,1,4);
        if not EOF(F)
        then readln(F,n) else n:=#0;
        PutVar(s,n);
      end else err('READ  OPEN');
    end else
    if 'OPEN'=copy(r,1,4) then
    begin
      Delete(s,1,4);
      x:=1;{1 -  , 2 -  }
           {3 -  , 4 -  }
      p:=oppos(' PRINTER',s);
      if p>0 then
      begin
        x:=4;
        AssignPrn(F); Rewrite(F);
      end else
      begin
        p:=oppos(' TO ',s);
        if p>0 then
        begin
          if 'READ'=UpperCase(trim(copy(s,p+4,len)))
          then x:=1 else
          if 'WRITE'=UpperCase(trim(copy(s,p+4,len)))
          then x:=2 else
          if 'APPEND'=UpperCase(trim(copy(s,p+4,len)))
          then x:=3 else err('OPEN TO ???');
          delete(s,p,len);
        end;
        n:=calc(s);
        if pos('.',n)=0 then n:=n+'.txt';
        AssignFile(F,n);
        case x of
          1:Reset(F);
          2:ReWrite(F);
          3:Append(F);
        end;
      end;
      Fm:=x;
    end else
    if 'CLOSE'=copy(r,1,5) then
    begin
      if Fm>0 then CloseFile(F)
      else err('CLOSE  OPEN');
      Fm:=0;
    end else
    if 'INCLUDE'=copy(r,1,7) then
    begin
      n:=calc(copy(s,8,len));
      if pos('.',n)=0 then n:=n+'.ab';
      AssignFile(F,n);
      Reset(F);
      While not EoF(F) do
      begin
        readln(F,s);
        MmProg.Lines.Add(s);
      end;
      CloseFile(F);
    end else
    if 'COLOR'=copy(r,1,5) then
    begin
      Pict.Canvas.Pen.Color:=clr(calc(copy(s,6,len)));
      if Hprint then MmHelp.Font.Color:=Pict.Canvas.Pen.Color;
    end else
    if 'WIDTH'=copy(r,1,5) then
    begin
      x:=round(num(calc(copy(s,6,len))));
      case x of
       -10..-1:begin
            Pict.Canvas.Pen.WIDTH:=1;
            Pict.Canvas.Pen.Style:=PsDot;
          end;
        0:begin
            Pict.Canvas.Pen.WIDTH:=1;
            Pict.Canvas.Pen.Style:=PsClear;
          end
        else begin
            Pict.Canvas.Pen.Style:=PsSolid;
            Pict.Canvas.Pen.WIDTH:=x;
          end;
      end;
    end else
    if 'LINE'=copy(r,1,4) then
    begin
      s:=UpperCase(trim(copy(s,5,len)));
      p:=oppos(' TO ',s);
      if p>1 then
      begin
        n:=calc(copy(s,1,p-1));
        x:=pos(':',n);
        if x=0 then x:=length(n)+1;
        y:=Round(num(copy(n,x+1,len)));
        x:=Round(num(copy(n,1,x-1)));
        Pict.Canvas.MoveTo(x,y);
      end;
      n:=calc(copy(s,p+4,len));
      x:=pos(':',n);
      if x=0 then x:=length(n)+1;
      y:=Round(num(copy(n,x+1,len)));
      x:=Round(num(copy(n,1,x-1)));
      Pict.Canvas.LineTo(x,y);
      Application.ProcessMessages;
    end else
    if 'PSET'=copy(r,1,4) then
    begin
      s:=UpperCase(trim(copy(s,5,len)));
      p:=oppos(' TO ',s);
      if p>1 then
      begin
        Pict.Canvas.Pen.Color:=clr(calc(copy(s,1,p-1)));
      end;
      n:=calc(copy(s,p+4,len));
      x:=pos(':',n);
      if x=0 then x:=length(n)+1;
      y:=Round(num(copy(n,x+1,len)));
      x:=Round(num(copy(n,1,x-1)));
      Pict.Canvas.MoveTo(x,y);
      Pict.Canvas.Pixels[x,y]:=Pict.Canvas.Pen.Color;
      Application.ProcessMessages;
    end else
    if 'CIRCLE'=copy(r,1,6) then
    begin
      p:=oppos(' TO ',s);
      if p>1 then
      begin
        n:=calc(copy(s,p+4,len));
        x:=pos(':',n);
        if x=0 then x:=length(n)+1;
        y:=Round(num(copy(n,x+1,len)));
        x:=Round(num(copy(n,1,x-1)));
      end else
      begin
        x:=Pict.Canvas.PenPos.x;
        y:=Pict.Canvas.PenPos.y;
        p:=length(s)+1;
      end;
      p:=Round(num(calc(copy(s,7,p-7))));
      Pict.Canvas.Brush.Style:=BsClear;
      Pict.Canvas.Ellipse(x-p,y-p,x+p,y+p);
      Pict.Canvas.MoveTo(x,y);
      Application.ProcessMessages;
    end else
    if 'ARC'=copy(r,1,3) then
    begin
      delete(s,1,3);
      while copy(s,1,1)=' ' do delete(s,1,1);
      r:=Uppercase(copy(s,1,2)); delete(s,1,2);
      p:=oppos(' TO ',s);
      if p>1 then
      begin
        n:=calc(copy(s,p+4,len));
        x:=pos(':',n);
        if x=0 then x:=length(n)+1;
        y:=Round(num(copy(n,x+1,len)));
        x:=Round(num(copy(n,1,x-1)));
      end else
      begin
        x:=Pict.Canvas.PenPos.x;
        y:=Pict.Canvas.PenPos.y;
        p:=length(s)+1;
      end;
      p:=Round(num(calc(copy(s,1,p-1))));
      Pict.Canvas.Brush.Style:=BsClear;
      if r='NW'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x,y-p,x-p,y)
      else if r='WS'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x-p,y,x,y+p)
      else if r='SO'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x,y+p,x+p,y)
      else if r='ON'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x+p,y,x,y-p)
      else if r='NS'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x,y-p,x,y+p)
      else if r='WO'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x-p,y,x+p,y)
      else if r='SN'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x,y+p,x,y-p)
      else if r='OW'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x+p,y,x-p,y)
      else if r='NO'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x,y-p,x+p,y)
      else if r='WN'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x-p,y,x,y-p)
      else if r='SW'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x,y+p,x-p,y)
      else if r='OS'
      then Pict.Canvas.Arc(x-p,y-p,x+p,y+p,x+p,y,x,y+p)
      else err('  .');
      Pict.Canvas.MoveTo(x,y);
      Application.ProcessMessages;
    end else
    if 'PAINT'=copy(r,1,5) then
    begin
      p:=oppos(' TO ',s);
      if p>1 then
      begin
        Pict.Canvas.Brush.Color:=Clr(calc(copy(s,6,p-6)));
      end;
      n:=calc(copy(s,p+4,len));
      x:=pos(':',n);
      if x=0 then x:=length(n)+1;
      y:=Round(num(copy(n,x+1,len)));
      x:=Round(num(copy(n,1,x-1)));
      Pict.Canvas.Brush.Style:=BsSolid;
      Pict.Canvas.FloodFill(x,y,Pict.Canvas.Pen.Color,FsBorder);
      Pict.Canvas.MoveTo(x,y);
      Application.ProcessMessages;
    end else
    if 'BOX'=copy(r,1,3) then
    begin
      delete(s,1,3);
      p:=Oppos(' TO ',s);
      if p>1 then
      begin
        n:=calc(copy(s,1,p-1));
        x:=pos(':',n);
        if x=0 then x:=length(n)+1;
        y:=Round(num(copy(n,x+1,len)));
        x:=Round(num(copy(n,1,x-1)));
      end;
      n:=calc(copy(s,p+4,len));
      p:=pos(':',n);
      if p=0 then p:=length(n)+1;
      q:=Round(num(copy(n,p+1,len)));
      p:=Round(num(copy(n,1,p-1)));
      Pict.Canvas.Brush.Color:=Pict.Canvas.Pen.Color;
      Pict.Canvas.Brush.Style:=BsSolid;
      Pict.Canvas.Rectangle(x,y,p,q);
      Application.ProcessMessages;
    end else
    if 'ELLIPSE'=copy(r,1,7) then
    begin
      delete(s,1,7);
      p:=Oppos(' TO ',s);
      if p>1 then
      begin
        n:=calc(copy(s,1,p-1));
        x:=pos(':',n);
        if x=0 then x:=length(n)+1;
        y:=Round(num(copy(n,x+1,len)));
        x:=Round(num(copy(n,1,x-1)));
      end;
      n:=calc(copy(s,p+4,len));
      p:=pos(':',n);
      if p=0 then p:=length(n)+1;
      q:=Round(num(copy(n,p+1,len)));
      p:=Round(num(copy(n,1,p-1)));
      Pict.Canvas.Brush.Style:=BsClear;
      Pict.Canvas.Ellipse(x,y,p,q);
      Pict.Canvas.MoveTo((x+p) div 2,(y+q) div 2);
      Application.ProcessMessages;
    end else
    if 'FONT'=copy(r,1,4) then
    begin
      delete(s,1,4);
      s:=UpperCase(calc(s));
      p:=pos('ITALIC',s);
      if p>0 then
      begin
        delete(s,p,6);
        Pict.Canvas.Font.Style:=[fsItalic];
      end;
      p:=pos('BOLD',s);
      if p>0 then
      begin
        delete(s,p,4);
        Pict.Canvas.Font.Style:=Pict.Canvas.Font.Style+[fsBold];
      end;
      p:=pos('NORNAL',s);
      if p>0 then
      begin
        delete(s,p,6);
        Pict.Canvas.Font.Style:=[];
      end;
      p:=pos('ARIAL',s);
      if p>0 then
      begin
        delete(s,p,5);
        Pict.Canvas.Font.Name:='Arial cyr';
      end;
      p:=pos('TIMES',s);
      if p>0 then
      begin
        delete(s,p,5);
        Pict.Canvas.Font.Name:='Times new roman cyr';
      end;
      p:=pos('COURIER',s);
      if p>0 then
      begin
        delete(s,p,5);
        Pict.Canvas.Font.Name:='Courier new cyr';
      end;
      x:=StrToIntDef(s,0);
      if x>0 then
        Pict.Canvas.Font.Size:=x;
    end else
    if 'IMAGE'=copy(r,1,5) then
    begin
      delete(s,1,5);
      s:=UpperCase(s);
      x:=0; y:=0;
      p:=oppos(' TO ',s);
      if p>0 then
      begin
        n:=calc(copy(s,p+4,len));
        x:=pos(':',n);
        if x=0 then x:=length(n)+1;
        y:=Round(num(copy(n,x+1,len)));
        x:=Round(num(copy(n,1,x-1)));
        delete(s,p,len);
      end;
      s:=trim(calc(s));
      if pos('.',s)=0 then s:=s+'.bmp';
      try
        Sprt.Picture.LoadFromFile(s)
      except
        Err('  :'+s);
      end;
      Pict.Canvas.Draw(x,y,Sprt.Picture.Bitmap);
      Application.ProcessMessages;
    end else
    if s<>'' then
    begin {  PRINT}
      if 'LET '=copy(r,1,4) then
      begin
        delete(s,1,4);
        delete(r,1,4);
      end;
      p:=oppos('=',s);
      if ('PRINT'<>copy(r,1,5)) and (p>0) then
      begin // 
        if trace and (copy(s,p-1,1)=':') then
        begin  Err(' =   : !');
          exit;
        end;
        n:=copy(s,1,p-1);
        delete(s,1,p);
        x:=pos('[',n);
        if x>0 then
        begin
          p:=pos(']',n);
          if p=0 then
          begin
            Err('  "]"  :'+n);
            exit;
          end;
          n:=copy(n,1,x)+calc(copy(n,x+1,p-x-1))+']';
        end;
        PutVar(n,Calc(s));
      end else {print}
      begin
        if 'PRINT'=copy(r,1,5) then delete(s,1,5);
        p:=oppos('HELP',s);
        if (p>0) or Hprint then
        begin
          delete(s,p,4);
          MmHelp.Lines.Add(calc(s));
        end else
        begin
          p:=oppos('HEAD',s);
          if p>0 then
          begin
            delete(s,p,4);
            Form1.Caption:=calc(s);
          end else
          begin
            p:=oppos(' TO ',s);
            if p>0 then
            begin
              n:=calc(copy(s,p+4,len));
              delete(s,p,len);
              x:=pos(':',n);
              if x=0 then x:=length(n)+1;
              ty:=Round(num(copy(n,x+1,len)));
              tx:=Round(num(copy(n,1,x-1)));
            end;
            Pict.Canvas.Font.Color:=Pict.Canvas.Pen.Color;
            Pict.Canvas.TextOut(tx,ty,calc(s));
            tx:=1;
            ty:=ty+Pict.Canvas.TextHeight('A')+1;
          end;
        end;
        Application.ProcessMessages;
      end;
    end;
    if not BtRun.Down then t:=MmProg.Lines.Count;
    t:=t+1;
  end;
  If Fm>0 then CloseFile(F);
  if Trace and (Ret>=0) then Err('    GOSUB');
  While MmProg.Lines.Count>Plen
  do MmProg.Lines.Delete(Plen);
  Rtext:=MmHelp.Text;
  Rfon:=MmHelp.Color;
  RColor:=MmHelp.Font.Color;
  BtRun.Down:=false;
end;{========================================}

procedure TForm1.BtHelpClick(Sender: TObject);
begin
  if not BtRun.Down then
  begin { .   !}
    MmHelp.Color:=ClAqua;
    MmHelp.Font.Color:=ClBlack;
    MmHelp.Text:=Htext;
  end;
  MmHelp.Visible:=true;
  MmHelp.BringToFront;
  MmHelp.SetFocus;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  PnPict.Width:=ClientWidth-PnPict.Left*2;
  PnPict.Height:=ClientHeight-PnPict.Top-PnPict.Left;
  MmProg.Top:=PnPict.Top;
  MmProg.Width:=PnPict.Width;
  MmProg.Height:=PnPict.Height;
  MmHelp.Top:=PnPict.Top;
  MmHelp.Width:=MmProg.Width;
  MmHelp.Height:=MmProg.Height;
  Vars.Top:=PnPict.Top;
  Vars.Width:=MmProg.Width;
  Vars.Height:=MmProg.Height;
  Vars.ColWidths[1]:=Vars.Width-Vars.ColWidths[0]-8;
end;

procedure TForm1.BtNewClick(Sender: TObject);
begin
  BtNew.Down:=true;
  if not Modify
  or Dial(' ?') then
  begin
    MmProg.Lines.Clear;
    Vars.RowCount:=1;
    Modify:=false;
    DlgSave.FileName:='New.ab';
    BtProgClick(BtProg);
  end;
  BtNew.Down:=false;
end;

procedure TForm1.BtOpenClick(Sender: TObject);
begin
  if not BtProg.Visible then exit;
  BtOpen.Down:=true;
  if DlgOpen.Execute
  and (not Modify or Dial(' ,  ?')) then
  begin
    MmProg.Lines.LoadFromFile(DlgOpen.FileName);
    Vars.RowCount:=1;
    DlgSave.FileName:=DlgOpen.FileName;
    Modify:=false;
    BtProgClick(BtProg);
  end;
  BtOpen.Down:=false;
end;

procedure TForm1.BtSaveClick(Sender: TObject);
begin
  BtSave.Down:=true;
  if DlgSave.Execute then
  begin
    if BtProg.Visible then BtProgClick(BtProg);
    MmProg.Lines.SaveToFile(DlgSave.FileName);
    Modify:=false;
  end;
  BtSave.Down:=false;
end;

procedure TForm1.BtPrintClick(Sender: TObject);
var t:longint; F:TextFile;
begin
  BtPrint.Down:=true;
  AssignPrn(F);
  Rewrite(F);
  Printer.Canvas.Font:=MmProg.Font;
  if BtHelp.Down then
  begin
    for t:=0 to Pred(MmHelp.Lines.Count)
    do Writeln(F,'  ',MmHelp.Lines[t]);
  end else
  if BtProg.Down then
  begin
    for t:=0 to Pred(MmProg.Lines.Count)
    do Writeln(F,'  ',MmProg.Lines[t]);
  end else
  if BtVars.Down then
  begin
    for t:=0 to Pred(Vars.RowCount)
    do Writeln(F,'  ',Vars.Cells[0,t]+' = '+Vars.Cells[1,t]);
  end else
  begin{}
    Printer.Canvas.Draw(10,10,Pict.Picture.Bitmap);
  end;
  CloseFile(F);
  BtPrint.Down:=false;
end;

procedure TForm1.MmProgChange(Sender: TObject);
begin
  Modify:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PnStart.Caption:=PnStart.Caption+' '+Ver;
  Application.HintColor:=ClAqua;
  Application.HintHidePause:=99999;
  Vars.RowCount:=1;
  Vars.Cells[0,0]:='PI';
  Vars.Cells[1,0]:=FloatToStr(Pi);
  tx:=1; ty:=1;
  Randomize;
  Htext:=MmHelp.Text;{.  }
  Hprint:=false;
  TmStart.Enabled:=true;
end;

procedure TForm1.BtProgClick(Sender: TObject);
begin
  BtRun.Down:=false;
  Form1.Caption:=ExtractFileName(DlgSave.FileName);
  MmProg.Visible:=true;
  MmProg.BringToFront;
  BtProg.Down:=true;
  MmProg.SetFocus;
  LbNom.Caption:='';
end;

procedure TForm1.BtDocClick(Sender: TObject);
begin
  if Hprint then
  begin
    MmHelp.Color:=Rfon;
    MmHelp.Font.Color:=Rcolor;
    MmHelp.Text:=Rtext;
    MmHelp.Visible:=true;
    MmHelp.BringToFront;
    MmHelp.SetFocus;
  end else
  begin
    BtDoc.Down:=true;
    PnPict.Visible:=true;
    PnPict.BringToFront;
  end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Case Key of
    vk_left:Tkey:=#1;
    vk_right:Tkey:=#2;
    vk_up:Tkey:=#3;
    vk_down:Tkey:=#4;
    vk_F1:BtHelpClick(BtHelp);
    vk_F2:BtSaveClick(BtSave);
    vk_F3:BtOpenClick(BtOpen);
    vk_F8:BtRun.Down:=false;
    vk_F9:begin BtRun.Down:=true;BtRunClick(BtRun);end;
    vk_F11:BtDocClick(BtDoc);
    vk_F12:if BtProg.Visible then BtProgClick(BtProg);
  end;
end;

procedure TForm1.MmProgKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var y:longint;
begin
  y:= SendMessage(MmProg.Handle, EM_LINEFROMCHAR, MmProg.SelStart, 0);
  LbNom.Caption:=intToStr(y+1);
end;

procedure TForm1.MmProgMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var t:longint;
begin
  t:= SendMessage(MmProg.Handle, EM_LINEFROMCHAR, MmProg.SelStart, 0);
  LbNom.Caption:=intToStr(t+1);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  BtRun.Down:=false;
  if Modify
   and not Dial(' ,   ?')
  then Action:=CaNone
  else Action:=CaFree;
end;

procedure TForm1.BtVarsClick(Sender: TObject);
begin
  BtVars.Down:=true;
  Vars.Visible:=true;
  Vars.BringToFront;
  Vars.SetFocus;
end;

procedure TForm1.PictMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Case Button of
    MbLeft:tKey:=#1;
    MbRight:tKey:=#2;
    else tKey:=#3;
  end;
end;

procedure TForm1.PictMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  mousex:=x;
  mousey:=y;
  if ssRight in Shift then tKey:=#2 else
  if ssLeft in Shift then tKey:=#1;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  mousex:=-1; mousey:=-1;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  TKey:=Key;
end;

procedure TForm1.VarsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=vk_Down) and (Vars.Row=Pred(Vars.RowCount)) then
  begin
    Vars.RowCount:=Succ(Vars.RowCount);
    Vars.Cells[0,Pred(Vars.RowCount)]:='';
    Vars.Cells[1,Pred(Vars.RowCount)]:='';
    Vars.Row:=Pred(Vars.RowCount);
    Vars.Col:=0
  end;
end;

procedure TForm1.VarsKeyPress(Sender: TObject; var Key: Char);
var s:string;
begin
  if Vars.Col=0 then
  begin
    s:=AnsiUpperCase(Key);
    Key:=s[1];
  end;
end;

procedure TForm1.TmStartTimer(Sender: TObject);
var s:string; i:longint;
begin
  TmStart.Enabled:=false;
  if ParamCount>0 then
  begin
    s:=ParamStr(1);
    for i:=2 to ParamCount do s:=s+' '+ParamStr(i);
    MmProg.Lines.LoadFromFile(s);
    Modify:=false;
    DlgSave.FileName:=s;
    Form1.Caption:=ExtractFileName(DlgSave.FileName);
    BtRun.Down:=true;
    PnStart.Visible:=false;
    Run;
  end
  else BtNewClick(BtNew);
end;

end.

